/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JPanel;

/**
 * Clase de Animacion.
 * @author Miguel Angel Pescador Santirso.
 */
public class Animacion {
final int ORIENTACION_SUR=0;
final int ORIENTACION_OESTE=1;
final int ORIENTACION_NORTE=2;
final int ORIENTACION_ESTE=3;
final int ACCION_PARAR=0;
final int ACCION_ANDAR=1;
final int ACCION_HABLAR=2;

Vector<ImageIcon> accion=new Vector<ImageIcon>(12);
Vector frames=new Vector(12);
int imagenamostrar=0;
private Image[] sprites;
int possprite=0;
Vector<Image[]> animaciones=new Vector<Image[]>(12);

/**
 * Constructor de la Animacion.
 * @param definicion Definicion de la animacion.
 */
    public Animacion(String definicion){
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        for (int i=0;i<12;i++){
            accion.add(null);
            frames.add(0);
            animaciones.add(null);
        }

        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            if(cadena.indexOf("0")!=-1||cadena.indexOf("1")!=-1||cadena.indexOf("2")!=-1){
                StringTokenizer sitio=new StringTokenizer(cadena," ");
                String pos;
                switch(Integer.parseInt(sitio.nextToken().trim())){
                    case ACCION_PARAR:switch(Integer.parseInt(sitio.nextToken().trim())){
                                            case ORIENTACION_SUR: 
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(0);
                                                frames.removeElementAt(0);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),0);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),0);
                                                break;
                                            case ORIENTACION_OESTE:
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(1);
                                                frames.removeElementAt(1);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),1);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),1);
                                                break;
                                            case ORIENTACION_NORTE:
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(2);
                                                frames.removeElementAt(2);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),2);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),2);
                                                break;
                                            case ORIENTACION_ESTE:
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(3);
                                                frames.removeElementAt(3);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),3);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),3);
                                                break;
                                    }
                                    break;
                    case ACCION_ANDAR:switch(Integer.parseInt(sitio.nextToken())){
                                            case ORIENTACION_SUR:
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(4);
                                                frames.removeElementAt(4);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),4);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),4);
                                                break;
                                            case ORIENTACION_OESTE:
                                                pos=sitio.nextToken();
                                                accion.removeElementAt(5);
                                                frames.removeElementAt(5);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),5);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),5);
                                                break;
                                            case ORIENTACION_NORTE:pos=sitio.nextToken();
                                            accion.removeElementAt(6);
                                                frames.removeElementAt(6);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),6);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),6);
                                                break;
                                            case ORIENTACION_ESTE:pos=sitio.nextToken();
                                            accion.removeElementAt(7);
                                                frames.removeElementAt(7);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),7);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),7);
                                                break;
                                    }
                                    break;
                    case ACCION_HABLAR:switch(Integer.parseInt(sitio.nextToken())){
                                            case ORIENTACION_SUR:pos=sitio.nextToken();
                                            accion.removeElementAt(8);
                                                frames.removeElementAt(8);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),8);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),8);
                                                break;
                                            case ORIENTACION_OESTE:pos=sitio.nextToken();
                                            accion.removeElementAt(9);
                                                frames.removeElementAt(9);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),9);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),9);
                                                break;
                                            case ORIENTACION_NORTE:pos=sitio.nextToken();
                                            accion.removeElementAt(10);
                                                frames.removeElementAt(10);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),10);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),10);
                                                break;
                                            case ORIENTACION_ESTE:pos=sitio.nextToken();
                                            accion.removeElementAt(11);
                                                frames.removeElementAt(11);
                                                accion.insertElementAt(new ImageIcon(pos.substring(1,pos.length()-1)),11);
                                                frames.insertElementAt(Integer.parseInt(sitio.nextToken().trim()),11);
                                                 break;
                            }
                        break;
                    
                }
               

            }
        }
         for (int m=0;m<accion.size();m++){
                    while(Integer.parseInt(frames.get(m).toString())==0)
                        m++;
                    animaciones.removeElementAt(m);
                    animaciones.insertElementAt(this.getAnimacion(m),m);
                    
                }
        
        }
/**
 * Devuelve la imagen del frame actual de la animacion.
 * @param i Número de frame de la animacion.
 * @return Image frame de la animacion.
 */
public Image getImagenEn(int i){
    while(Integer.parseInt(frames.get(i).toString())==0){
        i++;
    }
    Image[] ani=animaciones.get(i);
    if(Integer.parseInt(frames.get(i).toString())==1){
        return ani[0];
    }else{
        if(possprite>Integer.parseInt(frames.get(i).toString())-1){
            possprite=0;
        }
        //System.out.println(possprite);
        return ani[possprite];
}
    
}
/**
 * Esta funcion devuelve un array de imagenes con la animacion
 * solicitada.
 *
 * @param i Indice de la Animacion Solicitada.
 * @return Image[] con los frames de la Animacion Solicitada.
 */
public Image[] getAnimacion(int i){
    int nframes=Integer.parseInt(frames.get(i).toString());
    Image[] anim=new Image[nframes];
    int ancho=accion.elementAt(i).getImage().getWidth(null)/nframes;
    int alto=accion.elementAt(i).getImage().getHeight(null);
    int frame=0;
    BufferedImage buffimagen= new BufferedImage(ancho*nframes , alto, BufferedImage.TYPE_4BYTE_ABGR_PRE);
    Graphics buff=buffimagen.getGraphics();
    for(int j=0;j<nframes;j++){
        buff.drawImage(((ImageIcon)accion.elementAt(i)).getImage(),0,0, null);
        anim[j]=Toolkit.getDefaultToolkit().createImage( buffimagen.getSubimage(frame, 0, ancho, alto).getSource());
        frame+=ancho;
        }

    return anim;
    }

}
